#include <stdio.h>
#include <string.h>

long i,jcount,iok;

char* charpoint;

FILE* infile;
FILE* settingsfile;
FILE* outfile;
FILE* editlistfile;

char ChunkID[5],Format[5],Subchunk1ID[5],Subchunk2ID[5];
char indirname[512];
char infilename[512];
char editfilename[512];
char iodirectory[512];
char leafname[512];
char tempname[512];
char appdirname[512];
char settingsfilename[512];
char outdirname[512];
char outfilename[512];
char datablock[1152000];

char c1,c2;

long ChunkSize,Subchunk1Size,AudioFormat;
long NumChannels,SampleRate,ByteRate,BlockAlign;
long BitsPerSample,BytesPerSample;
long input_payload,output_payload,payload_done;

double input_duration_secs;

unsigned long Subchunk2Size;

long blocksize,blocks_per_file,bytes_written;
long sizeread;

long i,ok,filenumber,lastfile,mins_file,secs_file,secs_done,secs_end;

void get4(char*);
long get4int(void);
long get2int(void);
long read_header(void);
long read_settingsfile(void);

void write_output_header(long);
void write4(char*);
void write2int(long);
void write4int(long);

long produce_output_file(void);

int main(int argc,char*argv[])
{
  printf("WAVchopper v1.1\nJim Lesurf April 2010\n\n");
  i=argc;
  printf("Number of arguments given = %ld\n\n",i);
  
  sprintf(appdirname,"%s\0",argv[0]);
  ok=(long)strrchr(appdirname,'/')-(long)appdirname;
  appdirname[ok]=(char)0;
  printf("Application directory = %s\n",appdirname);
  sprintf(settingsfilename,"%s/%s\0",appdirname,"Settings\0");
  printf("Settings file at %s\n",settingsfilename);
  
  if(i==1)
  {
    printf("Drag an editfile to the Application icon\n");
    printf("to generate a series of output WAV files.\n");
    printf("Please read the help inside the application\n");
    printf("first for more details!\n\n");
  }
  
  if(i==2)
  {
    sprintf(editfilename,"%s\0",argv[1]);
    sprintf(iodirectory,"%s\0",editfilename);
    sprintf(leafname,"%s\0",1+strrchr(editfilename,'/'));
    ok=(long)strrchr(iodirectory,'/')-(long)iodirectory;
    iodirectory[ok]=(char)0;
    ok=(long)strrchr(iodirectory,'/')-(long)iodirectory;
    iodirectory[ok]=(char)0;
    printf("Edit file = %s\n",editfilename);
    printf(" leafname = %s \n",leafname);
    printf("I/O directory = %s\n",iodirectory);
    ok=read_settingsfile();
    infile=fopen(infilename,"rd");
    
    if(0!=(int)infile)
    {
      iok=read_header();
      printf("iok %ld\n",iok);
      
      
      input_payload=Subchunk2Size;
      input_duration_secs=(double)Subchunk2Size/(double)ByteRate;
      
      printf("Input %ld bytes long = %6.1lf sec duration\n",input_payload,input_duration_secs);
      secs_done=0; secs_end=0;
      payload_done=0;
      
      if(ByteRate<=1152000)
      {
        editlistfile=fopen(editfilename,"rt");
        filenumber=0; lastfile=0;
        while((fscanf(editlistfile,"%ld %ld",&mins_file,&secs_file)==2)&&(lastfile==0))
        {
          filenumber++;
          printf("%ld  %02ld  %02ld\n",filenumber,mins_file,secs_file);
          
          secs_file=secs_file+mins_file*60-secs_done;
          secs_end=secs_done+secs_file;
          
          if(secs_end>=(long)input_duration_secs)
          {
            printf("Edit time out of range!\n");
            lastfile=1;
            output_payload=input_payload-payload_done;
            secs_file=(long)input_duration_secs-secs_done;
          }
          else
          {
            output_payload=ByteRate*secs_file;
          }
            
          
          if (lastfile==1) printf("Last output file!\n");
          
          printf("File %ld Duration %ld sec with %ld payload\n",filenumber,secs_file,output_payload);
          
          ok=produce_output_file();
          if (ok==1) lastfile=1;
          payload_done+=output_payload;
          secs_done=secs_end;
        
        }
        
        fclose(editlistfile);
        
        if (payload_done<input_payload)
        {
          filenumber++;
          output_payload=input_payload-payload_done;
          printf("Now %ld remainder in last file\n",output_payload);
          ok=produce_output_file();
        }
      
      }
      else
      {
        printf("Byte Rate too high!\n");
      }
      fclose(infile);
    }
    else
    {
      printf("\n **Input wav file not found!**\n");
      printf("Please check names and locations!\n\n");
    }
    
    
  
  }
  
  printf("Done!\n");
  return 0;
}

long produce_output_file()
{
  long answer,payload_written;
  answer=0;
  sprintf(outfilename,"%s/%02ld_%s.wav\0",outdirname,filenumber,leafname);
  printf("Output to %s\n",outfilename);
  payload_written=0;
  outfile=fopen(outfilename,"wd");
  write_output_header(output_payload);
  
  if (lastfile==0)
  {
    do
    {
      sizeread=fread(datablock,sizeof(char),ByteRate,infile);
      fwrite(datablock,sizeof(char),sizeread,outfile);
      if(sizeread!=ByteRate) answer=1;
      payload_written+=ByteRate;
    } while (payload_written<output_payload);
  }
  else
  {
    do
    {
      sizeread=fread(datablock,sizeof(char),ByteRate,infile);
      fwrite(datablock,sizeof(char),sizeread,outfile);
    } while (sizeread==ByteRate);
  
  }
  
  fclose(outfile);
  return answer;
}

long read_settingsfile(void)
{
  long result;
  sprintf(settingsfilename,"%s/Settings\0",appdirname);
  printf("\nSettings file at %s\n",settingsfilename);

  settingsfile=fopen(settingsfilename,"rt");
  fscanf(settingsfile,"%s",tempname);
  sprintf(indirname,"%s/%s\0",iodirectory,tempname);
  printf("Input taken from   dir = %s\n",indirname);
  sprintf(infilename,"%s/%s.wav\0",indirname,leafname);
  printf(" from file = %s\n\n",infilename);
  
  fscanf(settingsfile,"%s",tempname);
  sprintf(outdirname,"%s/%s\0",iodirectory,tempname);
  printf("Output will go into dir = %s\n",outdirname);
  
  fclose(settingsfile);
  result=1;
  return result;
}

long read_header(void)
{
  long irh;

   printf("Reading header\n");
    
    get4(ChunkID);
    printf("ChunkID = %s\n",ChunkID);
    ChunkSize=get4int();
    printf("Chunk Size = %ld\n",ChunkSize);
    get4(Format);
    printf("Format = %s\n",Format);
    get4(Subchunk1ID);
    printf("Subchunk1ID = %s\n",Subchunk1ID);
    Subchunk1Size=get4int();
    AudioFormat=get2int();
    if((Subchunk1Size==16)&&(AudioFormat==1))
    {
      printf("16 bits per sample LPCM format OK\n");
    }
    else
    {
      printf("Format unknown!\n");
    }
    NumChannels=get2int();
    printf("Number of Channels = %ld\n",NumChannels);
    SampleRate=get4int();
    printf("Sample Rate = %ld\n",SampleRate);
    ByteRate=get4int();
    printf("Byte Rate = %ld\n",ByteRate);
    BlockAlign=get2int();
    printf("Block Align = %ld\n",BlockAlign);
    BitsPerSample=get2int();
    printf("Bits per sample = %ld\n",BitsPerSample);
    BytesPerSample=BitsPerSample/8;
    printf("Bytes per sample = %ld\n",BytesPerSample);
    
    get4(Subchunk2ID);
    printf("Subchunk2ID = %s\n",Subchunk2ID);
    Subchunk2Size=(unsigned long)get4int();
    printf("Subchunk2Size = %lu [Number of Data payload bytes]\n",Subchunk2Size);
    
  irh=ByteRate;
  return irh;
}



long get2int(void)
{
  long result;
  unsigned char cip1,cip2;
  
  fscanf(infile,"%c",&cip1);
  fscanf(infile,"%c",&cip2);

  result=(long)cip2;
  result=(long)cip1+256*result;

  return result;
} 

long get4int(void)
{
  long result;
  unsigned char cip1,cip2,cip3,cip4;
  
  fscanf(infile,"%c",&cip1);
  fscanf(infile,"%c",&cip2);
  fscanf(infile,"%c",&cip3);
  fscanf(infile,"%c",&cip4);
    
  result=(long)cip4;
  result=(long)cip3+256*result;
  result=(long)cip2+256*result;
  result=(long)cip1+256*result;
  
  return result;
} 
void get4(char* outstring)
{
  long isp;
  char csp;
  isp=0;
  do
  {
    fscanf(infile,"%c",&csp);
    outstring[isp]=csp;
    isp++;
  } while (isp<4);
  outstring[4]=(char)0;

}


void write4int(long inv)
{
  char cop1,cop2,cop3,cop4;
  
  cop1=(unsigned char)(inv&255);
  cop2=(unsigned char)((inv>>8)&255);
  cop3=(unsigned char)((inv>>16)&255);
  cop4=(unsigned char)((inv>>24)&255);
  
  fprintf(outfile,"%c",cop1);
  fprintf(outfile,"%c",cop2);
  fprintf(outfile,"%c",cop3);
  fprintf(outfile,"%c",cop4);
}


void write2int(long inv)
{
  unsigned char cop1,cop2;
  cop1=(unsigned char)(inv&255);
  cop2=(unsigned char)((inv>>8)&255);
  fprintf(outfile,"%c",cop1);
  fprintf(outfile,"%c",cop2);
}

void write4(char* outstring)
{
  int isp;
  
  isp=0;
  do
  {
    fprintf(outfile,"%c",outstring[isp]);
    isp++;
  } while (isp<4);
  
}


void write_output_header(long plo)
{
  
  printf("Payload to write = %ld\n\n",plo);
  write4(ChunkID);
  write4int(plo+36);
  write4(Format);
  write4(Subchunk1ID);
  write4int(Subchunk1Size);
  write2int(AudioFormat);
  write2int(NumChannels);
  write4int(SampleRate);
  write4int(ByteRate);
  write2int(BlockAlign);
  write2int(BitsPerSample);
  write4(Subchunk2ID);
  write4int(plo);
  
}

